# test02.rb
# removes comments from a C source file -- rudimentary
# by pts@fazekas.hu at Thu Dec 14 17:41:06 CET 2000
#
  require "flex"
  
  f=Flex.new([nil,nil,
    '[a-zA-Z_][_a-zA-Z0-9]*',		# 2 # identifier
    %q#\"([^\"\\\\]|(\\\\\\\\)*\\\\(.|\n))*\"#,	# 3 # string constant
    %q#\'([^\'\\\\]|(\\\\\\\\)*\\\\(.|\n))*\'#,	# 4 # char constant
    '\/\*([^*]|\*+[^*/])*\*+\/',	# 5 # comment
    '(0x)?[0-9]+[uUlL]?',		# 6 # integer
    '\n#[a-zA-Z]+[ \t\r\n][^\n]*(\\\\\n[^\n]*)*', # 7 # preprocessor directive
    '[ \t\r\n]',			# 8 # whitespace
    '.'					# 9 # anything else
  ]);
  f.opts=Flex::OPT_REMEMBER

  def next_chunk(fi)
    begin
      return fi.sysread(4096)
    rescue EOFError
      return false
    end
  end

  f.reset
  fi=File.open "flexinit.c","r";
  while f.each_token(next_chunk(fi)) {|i|
    print f.yytext if i!=5
  }; end
